#ifndef __signal_emiter_h__
#define __signal_emiter_h__
#include <glib-object.h>
G_BEGIN_DECLS

/*
 * Type macros.
 */
#define EMITTER_TYPE                  (emitter_get_type ())
#define EMITTER(obj)                  (G_TYPE_CHECK_INSTANCE_CAST ((obj), EMITTER_TYPE, Emitter))
#define EMITTER_IS(obj)               (G_TYPE_CHECK_INSTANCE_TYPE ((obj), EMITTER_TYPE))
#define EMITTER_CLASS(klass)          (G_TYPE_CHECK_CLASS_CAST ((klass), EMITTER_TYPE, EmitterClass))
#define EMITTER_IS_CLASS(klass)       (G_TYPE_CHECK_CLASS_TYPE ((klass), EMITTER_TYPE))
#define EMITTER_GET_CLASS(obj)        (G_TYPE_INSTANCE_GET_CLASS ((obj), EMITTER_TYPE, EmitterClass))

typedef struct _Emitter           Emitter;
typedef struct _EmitterClass    EmitterClass;
typedef struct _EmitterPrivate EmitterPrivate;

struct _Emitter
{
  GObject parent_instance;

/*< private >*/
  EmitterPrivate *priv;

  /* instance members */

};

struct _EmitterClass
{
  GObjectClass parent_class;

  /* class members */


/* signals */
    
    void (*parameter_changed)(Emitter *);
    void (*ready)(Emitter *);
    void (*start)(Emitter *);
    void (*finished)(Emitter *);


};

/* used by EMITTER_TYPE */
GType emitter_get_type (void);

/*
 * Method definitions.
 */
Emitter *emitter_new();

G_END_DECLS

#endif
