# AC_PATH_FILES(variable, file-to-check-for, [value if not found], [PATH])
#------------------------------------------------------------------------ 
#
AC_DEFUN([AC_PATH_FILES],
[# Finds the path of a file
set dummy $2; ac_word=$[2]
AC_MSG_CHECKING([for $ac_word])
AC_CACHE_VAL([ac_cv_path_$1],
[case $$1 in
  [[\\/]]* | ?:[[\\/]]*)
  ac_cv_path_$1="$$1" # Let the user override the test with a path.
  ;;
  *)
  _AS_PATH_WALK([$4],
[if test -e $as_dir/$ac_word; then
	ac_cv_path_$1="$as_dir/$ac_word"
	_AS_ECHO_LOG([found $as_dir/$ac_word])
	break 2
fi])
dnl If no 3rd arg is given, leave the cache variable unset,
dnl so AC_PATH_FILES will keep looking.
m4_ifvaln([$3],
[  test -z "$ac_cv_path_$1" && ac_cv_path_$1="$3"])dnl
  ;;
esac])dnl
$1=$ac_cv_path_$1
if test -n "$$1"; then
  AC_MSG_RESULT([$$1])
else
  AC_MSG_RESULT([no])
fi
])# AC_PATH_FILES
