/*
 * CalibrationRun.h
 *
 *  Created on: May 12, 2010
 *      Author: lacasta
 */

#ifndef CALIBRATIONRUN_H_
#define CALIBRATIONRUN_H_

#include "RunManager.h"

class CalibrationRun: public RunManager
{
    public:
        CalibrationRun(DAQmanager *D);
        virtual ~CalibrationRun();

        int loop(std::ostream &header);
        int acquire(unsigned int val);
        int read_data() { return 0; }
        void start_of_run();
};

class ChargeScanRun: public RunManager
{
    public:
        ChargeScanRun(DAQmanager *D);
        virtual ~ChargeScanRun() {}

        int loop(std::ostream &header);
        int acquire(unsigned int val) { return 0; }
        int read_data() { return 0; }
        void start_of_run();

};

#endif /* CALIBRATIONRUN_H_ */
